Index: src/sans/fit/BumpsFitting.py
===================================================================
--- src/sans/fit/BumpsFitting.py	(revision eff93b8d577de85b34ffd99e484da07484c35580)
+++ src/sans/fit/BumpsFitting.py	(revision eff93b8d577de85b34ffd99e484da07484c35580)
@@ -0,0 +1,270 @@
+"""
+BumpsFitting module runs the bumps optimizer.
+"""
+import numpy
+
+from bumps import fitters
+from bumps.mapper import SerialMapper
+from bumps import parameter
+from bumps.fitproblem import FitProblem
+
+from .AbstractFitEngine import FitEngine
+from .AbstractFitEngine import FResult
+from .expression import compile_constraints
+
+class BumpsMonitor(object):
+    def __init__(self, handler, max_step=0):
+        self.handler = handler
+        self.max_step = max_step
+
+    def config_history(self, history):
+        history.requires(time=1, value=2, point=1, step=1)
+
+    def __call__(self, history):
+        if self.handler is None: return
+        self.handler.progress(history.step[0], self.max_step)
+        if len(history.step)>1 and history.step[1] > history.step[0]:
+            self.handler.improvement()
+        self.handler.update_fit()
+
+class ConvergenceMonitor(object):
+    """
+    ConvergenceMonitor contains population summary statistics to show progress
+    of the fit.  This is a list [ (best, 0%, 25%, 50%, 75%, 100%) ] or
+    just a list [ (best, ) ] if population size is 1.
+    """
+    def __init__(self):
+        self.convergence = []
+
+    def config_history(self, history):
+        history.requires(value=1, population_values=1)
+
+    def __call__(self, history):
+        best = history.value[0]
+        try:
+            p = history.population_values[0]
+            n,p = len(p), numpy.sort(p)
+            QI,Qmid, = int(0.2*n),int(0.5*n)
+            self.convergence.append((best, p[0],p[QI],p[Qmid],p[-1-QI],p[-1]))
+        except:
+            self.convergence.append((best, best,best,best,best,best))
+
+
+# Note: currently using bumps parameters for each parameter object so that
+# a SasFitness can be used directly in bumps with the usual semantics.
+# The disadvantage of this technique is that we need to copy every parameter
+# back into the model each time the function is evaluated.  We could instead
+# define reference parameters for each sans parameter, but then we would not
+# be able to express constraints using python expressions in the usual way
+# from bumps, and would instead need to use string expressions.
+class SasFitness(object):
+    """
+    Wrap SAS model as a bumps fitness object
+    """
+    def __init__(self, model, data, fitted=[], constraints={}, **kw):
+        self.name = model.name
+        self.model = model.model
+        self.data = data
+        self._define_pars()
+        self._init_pars(kw)
+        self.constraints = dict(constraints)
+        self.set_fitted(fitted)
+        self._dirty = True
+
+    def _define_pars(self):
+        self._pars = {}
+        for k in self.model.getParamList():
+            name = ".".join((self.name,k))
+            value = self.model.getParam(k)
+            bounds = self.model.details.get(k,["",None,None])[1:3]
+            self._pars[k] = parameter.Parameter(value=value, bounds=bounds,
+                                                fixed=True, name=name)
+        #print parameter.summarize(self._pars.values())
+
+    def _init_pars(self, kw):
+        for k,v in kw.items():
+            # dispersion parameters initialized with _field instead of .field
+            if k.endswith('_width'): k = k[:-6]+'.width'
+            elif k.endswith('_npts'): k = k[:-5]+'.npts'
+            elif k.endswith('_nsigmas'): k = k[:-7]+'.nsigmas'
+            elif k.endswith('_type'): k = k[:-5]+'.type'
+            if k not in self._pars:
+                formatted_pars = ", ".join(sorted(self._pars.keys()))
+                raise KeyError("invalid parameter %r for %s--use one of: %s"
+                               %(k, self.model, formatted_pars))
+            if '.' in k and not k.endswith('.width'):
+                self.model.setParam(k, v)
+            elif isinstance(v, parameter.BaseParameter):
+                self._pars[k] = v
+            elif isinstance(v, (tuple,list)):
+                low, high = v
+                self._pars[k].value = (low+high)/2
+                self._pars[k].range(low,high)
+            else:
+                self._pars[k].value = v
+        self.update()
+
+    def set_fitted(self, param_list):
+        """
+        Flag a set of parameters as fitted parameters.
+        """
+        for k,p in self._pars.items():
+            p.fixed = (k not in param_list or k in self.constraints)
+        self.fitted_pars = [self._pars[k] for k in param_list if k not in self.constraints]
+        self.fitted_par_names = [k for k in param_list if k not in self.constraints]
+
+    # ===== Fitness interface ====
+    def parameters(self):
+        return self._pars
+
+    def update(self):
+        for k,v in self._pars.items():
+            #print "updating",k,v,v.value
+            self.model.setParam(k,v.value)
+        self._dirty = True
+
+    def _recalculate(self):
+        if self._dirty:
+            self._residuals, self._theory = self.data.residuals(self.model.evalDistribution)
+            self._dirty = False
+
+    def numpoints(self):
+        return numpy.sum(self.data.idx) # number of fitted points
+
+    def nllf(self):
+        return 0.5*numpy.sum(self.residuals()**2)
+
+    def theory(self):
+        self._recalculate()
+        return self._theory
+
+    def residuals(self):
+        self._recalculate()
+        return self._residuals
+
+    # Not implementing the data methods for now:
+    #
+    #     resynth_data/restore_data/save/plot
+
+class BumpsFit(FitEngine):
+    """
+    Fit a model using bumps.
+    """
+    def __init__(self):
+        """
+        Creates a dictionary (self.fit_arrange_dict={})of FitArrange elements
+        with Uid as keys
+        """
+        FitEngine.__init__(self)
+        self.curr_thread = None
+
+    def fit(self, msg_q=None,
+            q=None, handler=None, curr_thread=None,
+            ftol=1.49012e-8, reset_flag=False):
+        # Build collection of bumps fitness calculators
+        models = [ SasFitness(model=M.get_model(),
+                              data=M.get_data(),
+                              constraints=M.constraints,
+                              fitted=M.pars)
+                   for i,M in enumerate(self.fit_arrange_dict.values())
+                   if M.get_to_fit() == 1 ]
+        if len(models) == 0:
+            raise RuntimeError("Nothing to fit")
+        problem = FitProblem(models)
+
+
+        # Build constraint expressions
+        exprs = {}
+        for M in models:
+            exprs.update((".".join((M.name,k)),v) for k,v in M.constraints.items())
+        if exprs:
+            symtab = dict((".".join((M.name,k)),p)
+                          for M in models
+                          for k,p in M.parameters().items())
+            constraints = compile_constraints(symtab,exprs)
+        else:
+            constraints = lambda: 0
+
+        # Override model update so that parameter constraints are applied
+        problem._model_update = problem.model_update
+        def model_update():
+            constraints()
+            problem._model_update()
+        problem.model_update = model_update
+
+        # Run the fit
+        result = run_bumps(problem, handler, curr_thread)
+        if handler is not None:
+            handler.update_fit(last=True)
+
+        # TODO: shouldn't reference internal parameters of fit problem
+        varying = problem._parameters
+        # collect the results
+        all_results = []
+        for M in problem.models:
+            fitness = M.fitness
+            fitted_index = [varying.index(p) for p in fitness.fitted_pars]
+            R = FResult(model=fitness.model, data=fitness.data,
+                        param_list=fitness.fitted_par_names)
+            R.theory = fitness.theory()
+            R.residuals = fitness.residuals()
+            R.fitter_id = self.fitter_id
+            # TODO: should scale stderr by sqrt(chisq/DOF) if dy is unknown
+            R.stderr = result['stderr'][fitted_index]
+            R.pvec = result['value'][fitted_index]
+            R.success = result['success']
+            R.fitness = numpy.sum(R.residuals**2)/(fitness.numpoints() - len(fitted_index))
+            R.convergence = result['convergence']
+            if result['uncertainty'] is not None:
+                R.uncertainty_state = result['uncertainty']
+            all_results.append(R)
+
+        if q is not None:
+            q.put(all_results)
+            return q
+        else:
+            return all_results
+
+def run_bumps(problem, handler, curr_thread):
+    def abort_test():
+        if curr_thread is None: return False
+        try: curr_thread.isquit()
+        except KeyboardInterrupt:
+            if handler is not None:
+                handler.stop("Fitting: Terminated!!!")
+            return True
+        return False
+
+    fitopts = fitters.FIT_OPTIONS[fitters.FIT_DEFAULT]
+    fitclass = fitopts.fitclass
+    options = fitopts.options.copy()
+    max_step = fitopts.options.get('steps', 0) + fitopts.options.get('burn', 0)
+    options['monitors'] = [
+        BumpsMonitor(handler, max_step),
+        ConvergenceMonitor(),
+        ]
+    fitdriver = fitters.FitDriver(fitclass, problem=problem,
+                                  abort_test=abort_test, **options)
+    mapper = SerialMapper 
+    fitdriver.mapper = mapper.start_mapper(problem, None)
+    #import time; T0 = time.time()
+    try:
+        best, fbest = fitdriver.fit()
+    except:
+        import traceback; traceback.print_exc()
+        raise
+    finally:
+        mapper.stop_mapper(fitdriver.mapper)
+
+
+    convergence_list = options['monitors'][-1].convergence
+    convergence = (2*numpy.asarray(convergence_list)/problem.dof
+                   if convergence_list else numpy.empty((0,1),'d'))
+    return {
+        'value': best,
+        'stderr': fitdriver.stderr(),
+        'success': True, # better success reporting in bumps
+        'convergence': convergence,
+        'uncertainty': getattr(fitdriver.fitter, 'state', None),
+        }
+
Index: src/sans/fit/Fitting.py
===================================================================
--- src/sans/fit/Fitting.py	(revision 5777106e8a4a0a62fe2ee0fbaf7c0aa19c0bb92b)
+++ src/sans/fit/Fitting.py	(revision e3efa6b33f61b244c04b2476cabdadf01a183b76)
@@ -8,5 +8,11 @@
 from sans.fit.ScipyFitting import ScipyFit
 from sans.fit.ParkFitting import ParkFit
+from sans.fit.BumpsFitting import BumpsFit
 
+ENGINES={
+    'scipy': ScipyFit,
+    'park': ParkFit,
+    'bumps': BumpsFit,
+}
 
 class Fit(object):
@@ -26,5 +32,5 @@
         
     """  
-    def __init__(self, engine='scipy'):
+    def __init__(self, engine='scipy', *args, **kw):
         """
         """
@@ -32,5 +38,5 @@
         self._engine = None
         self.fitter_id = None
-        self.set_engine(engine)
+        self.set_engine(engine, *args, **kw)
           
     def __setattr__(self, name, value):
@@ -49,5 +55,5 @@
             self.__dict__[name] = value
                 
-    def set_engine(self, word):
+    def set_engine(self, word, *args, **kw):
         """
         Select the type of Fit 
@@ -59,10 +65,8 @@
              
         """
-        if word == "scipy":
-            self._engine = ScipyFit()
-        elif word == "park":
-            self._engine = ParkFit()
-        else:
-            raise ValueError, "enter the keyword scipy or park"
+        try:
+            self._engine = ENGINES[word](*args, **kw)
+        except KeyError, exc:
+            raise KeyError("fit engine should be one of scipy, park or bumps")
 
     def fit(self, msg_q=None, q=None, handler=None, 
Index: src/sans/fit/Loader.py
===================================================================
--- src/sans/fit/Loader.py	(revision 5777106e8a4a0a62fe2ee0fbaf7c0aa19c0bb92b)
+++ src/sans/fit/Loader.py	(revision 6fe51002a81260397b29374005fb3e465ff93b4a)
@@ -8,6 +8,6 @@
     This class is loading values from given file or value giving by the user
     """
-    
     def __init__(self, x=None, y=None, dx=None, dy=None):
+        raise NotImplementedError("a code search shows that this code is not active, and you are not seeing this message")
         # variable to store loaded values
         self.x = x
Index: src/sans/fit/ParkFitting.py
===================================================================
--- src/sans/fit/ParkFitting.py	(revision 9d6d5bac0acbf70af7fa2fc5a5951c6d7a8c9f91)
+++ src/sans/fit/ParkFitting.py	(revision 8d074d926d99193a8c902448957d621abd9235d5)
@@ -24,5 +24,156 @@
 from sans.fit.AbstractFitEngine import FitEngine
 from sans.fit.AbstractFitEngine import FResult
-  
+
+class SansParameter(park.Parameter):
+    """
+    SANS model parameters for use in the PARK fitting service.
+    The parameter attribute value is redirected to the underlying
+    parameter value in the SANS model.
+    """
+    def __init__(self, name, model, data):
+        """
+            :param name: the name of the model parameter
+            :param model: the sans model to wrap as a park model
+        """
+        park.Parameter.__init__(self, name)
+        #self._model, self._name = model, name
+        self.data = data
+        self.model = model
+        #set the value for the parameter of the given name
+        self.set(model.getParam(name))
+
+        # TODO: model is missing parameter ranges for dispersion parameters
+        if name not in model.details:
+            #print "setting details for",name
+            model.details[name] = ["", None, None]
+
+    def _getvalue(self):
+        """
+        override the _getvalue of park parameter
+
+        :return value the parameter associates with self.name
+
+        """
+        return self.model.getParam(self.name)
+
+    def _setvalue(self, value):
+        """
+        override the _setvalue pf park parameter
+
+        :param value: the value to set on a given parameter
+
+        """
+        self.model.setParam(self.name, value)
+
+    value = property(_getvalue, _setvalue)
+
+    def _getrange(self):
+        """
+        Override _getrange of park parameter
+        return the range of parameter
+        """
+        #if not  self.name in self._model.getDispParamList():
+        lo, hi = self.model.details[self.name][1:3]
+        if lo is None: lo = -numpy.inf
+        if hi is None: hi = numpy.inf
+        if lo > hi:
+            raise ValueError, "wrong fit range for parameters"
+
+        return lo, hi
+
+    def get_name(self):
+        """
+        """
+        return self._getname()
+
+    def _setrange(self, r):
+        """
+        override _setrange of park parameter
+
+        :param r: the value of the range to set
+
+        """
+        self.model.details[self.name][1:3] = r
+    range = property(_getrange, _setrange)
+
+
+class ParkModel(park.Model):
+    """
+    PARK wrapper for SANS models.
+    """
+    def __init__(self, sans_model, sans_data=None, **kw):
+        """
+        :param sans_model: the sans model to wrap using park interface
+
+        """
+        park.Model.__init__(self, **kw)
+        self.model = sans_model
+        self.name = sans_model.name
+        self.data = sans_data
+        #list of parameters names
+        self.sansp = sans_model.getParamList()
+        #list of park parameter
+        self.parkp = [SansParameter(p, sans_model, sans_data) for p in self.sansp]
+        #list of parameter set
+        self.parameterset = park.ParameterSet(sans_model.name, pars=self.parkp)
+        self.pars = []
+
+    def get_params(self, fitparams):
+        """
+        return a list of value of paramter to fit
+
+        :param fitparams: list of paramaters name to fit
+
+        """
+        list_params = []
+        self.pars = fitparams
+        for item in fitparams:
+            for element in self.parkp:
+                if element.name == str(item):
+                    list_params.append(element.value)
+        return list_params
+
+    def set_params(self, paramlist, params):
+        """
+        Set value for parameters to fit
+
+        :param params: list of value for parameters to fit
+
+        """
+        try:
+            for i in range(len(self.parkp)):
+                for j in range(len(paramlist)):
+                    if self.parkp[i].name == paramlist[j]:
+                        self.parkp[i].value = params[j]
+                        self.model.setParam(self.parkp[i].name, params[j])
+        except:
+            raise
+
+    def eval(self, x):
+        """
+            Override eval method of park model.
+
+            :param x: the x value used to compute a function
+        """
+        try:
+            return self.model.evalDistribution(x)
+        except:
+            raise
+
+    def eval_derivs(self, x, pars=[]):
+        """
+        Evaluate the model and derivatives wrt pars at x.
+
+        pars is a list of the names of the parameters for which derivatives
+        are desired.
+
+        This method needs to be specialized in the model to evaluate the
+        model function.  Alternatively, the model can implement is own
+        version of residuals which calculates the residuals directly
+        instead of calling eval.
+        """
+        return []
+
+
 class SansFitResult(fitresult.FitResult):
     def __init__(self, *args, **kwrds):
@@ -244,5 +395,5 @@
         return fitpars
     
-    def all_results(self, result):
+    def extend_results_with_calculated_parameters(self, result):
         """
         Extend result from the fit with the calculated parameters.
@@ -292,10 +443,10 @@
                 # dividing residuals by N in order to be consistent with Scipy
                 m.chisq = numpy.sum(m.residuals**2/N) 
-                resid.append(m.weight*m.residuals/math.sqrt(N))
+                resid.append(m.weight*m.residuals)
         self.residuals = numpy.hstack(resid)
         N = len(self.residuals)
         self.degrees_of_freedom = N-k if N>k else 1
         self.chisq = numpy.sum(self.residuals**2)
-        return self.chisq
+        return self.chisq/self.degrees_of_freedom
     
 class ParkFit(FitEngine):
@@ -354,9 +505,10 @@
             if fproblem.get_to_fit() == 1:
                 fitproblems.append(fproblem)
-        if len(fitproblems) == 0: 
+        if len(fitproblems) == 0:
             raise RuntimeError, "No Assembly scheduled for Park fitting."
-            return
         for item in fitproblems:
-            parkmodel = item.get_model()
+            model = item.get_model()
+            parkmodel = ParkModel(model.model, model.data)
+            parkmodel.pars = item.pars
             if reset_flag:
                 # reset the initial value; useful for batch
@@ -364,9 +516,13 @@
                     ind = item.pars.index(name)
                     parkmodel.model.setParam(name, item.vals[ind])
+
+            # set the constraints into the model
+            for p,v in item.constraints:
+                parkmodel.parameterset[str(p)].set(str(v))
             
             for p in parkmodel.parameterset:
                 ## does not allow status change for constraint parameters
                 if p.status != 'computed':
-                    if p.get_name()in item.pars:
+                    if p.get_name() in item.pars:
                         ## make parameters selected for 
                         #fit will be between boundaries
@@ -383,5 +539,5 @@
     def fit(self, msg_q=None, 
             q=None, handler=None, curr_thread=None, 
-                                        ftol=1.49012e-8, reset_flag=False):
+            ftol=1.49012e-8, reset_flag=False):
         """
         Performs fit with park.fit module.It can  perform fit with one model
@@ -407,5 +563,6 @@
         localfit = SansFitSimplex()
         localfit.ftol = ftol
-        
+        localfit.xtol = 1e-6
+
         # See `park.fitresult.FitHandler` for details.
         fitter = SansFitMC(localfit=localfit, start_points=1)
@@ -416,8 +573,11 @@
         try:
             result = fit.fit(self.problem, fitter=fitter, handler=handler)
-            self.problem.all_results(result)
+            self.problem.extend_results_with_calculated_parameters(result)
             
         except LinAlgError:
             raise ValueError, "SVD did not converge"
+
+        if result is None:
+            raise RuntimeError("park did not return a fit result")
     
         for m in self.problem.parts:
@@ -427,22 +587,26 @@
             small_result.theory = theory
             small_result.residuals = residuals
-            small_result.pvec = []
-            small_result.cov = []
-            small_result.stderr = []
-            small_result.param_list = []
-            small_result.residuals = m.residuals
-            if result is not None:
-                for p in result.parameters:
-                    if p.data.name == small_result.data.name and \
-                            p.model.name == small_result.model.name:
-                        small_result.index = m.data.idx
-                        small_result.fitness = result.fitness
-                        small_result.pvec.append(p.value)
-                        small_result.stderr.append(p.stderr)
-                        name_split = p.name.split('.')
-                        name = name_split[1].strip()
-                        if len(name_split) > 2:
-                            name += '.' + name_split[2].strip()
-                        small_result.param_list.append(name)
+            small_result.index = m.data.idx
+            small_result.fitness = result.fitness
+
+            # Extract the parameters that are part of this model; make sure
+            # they match the fitted parameters for this model, and place them
+            # in the same order as they occur in the model.
+            pars = {}
+            for p in result.parameters:
+                #if p.data.name == small_result.data.name and
+                if p.model.name == small_result.model.name:
+                    model_name, par_name = p.name.split('.', 1)
+                    pars[par_name] = (p.value, p.stderr)
+            #assert len(pars.keys()) == len(m.model.pars)
+            v,dv = zip(*[pars[p] for p in m.model.pars])
+            small_result.pvec = v
+            small_result.stderr = dv
+            small_result.param_list = m.model.pars
+
+            # normalize chisq by degrees of freedom
+            dof = len(small_result.residuals)-len(small_result.pvec)
+            small_result.fitness = numpy.sum(residuals**2)/dof
+
             result_list.append(small_result)    
         if q != None:
